org.apache.cassandra.db

## Interface ColumnFamilyStoreMBean

All Known Implementing Classes:
  ColumnFamilyStore

    public interface ColumnFamilyStoreMBean

The MBean interface for ColumnFamilyStore

### Method Summary

All Methods Instance Methods Abstract Methods Deprecated Methods
`void` `beginLocalSampling(java.lang.String sampler, int capacity)` begin sampling for a specific sampler with a given capacity.
`long` `estimateKeys()`
`javax.management.openmbean.CompositeData` `finishLocalSampling(java.lang.String sampler, int count)`
`void` `forceMajorCompaction(boolean splitOutput)` force a major compaction of this column family
`java.util.List<java.lang.String>` `getBuiltIndexes()` Returns a list of the names of the built column indexes for current store
`java.lang.String` `getColumnFamilyName()`
`java.util.Map<java.lang.String,java.lang.String>` `getCompactionParameters()`
`java.lang.String` `getCompactionParametersJson()`
`java.lang.String` `getCompactionStrategyClass()` Deprecated.
`java.util.Map<java.lang.String,java.lang.String>` `getCompressionParameters()` Get the compression parameters
`double` `getDroppableTombstoneRatio()` Get the ratio of droppable tombstones to real columns (and non-droppable tombstones)
`int` `getMaximumCompactionThreshold()` Gets the maximum number of sstables in queue before compaction kicks off
`int` `getMinimumCompactionThreshold()` Gets the minimum number of sstables in queue before compaction kicks off
`int[]` `getSSTableCountPerLevel()`
`java.util.List<java.lang.String>` `getSSTablesForKey(java.lang.String key)` Returns a list of filenames that contain the given key on this node
`int` `getUnleveledSSTables()`
`boolean` `isAutoCompactionDisabled()`
`void` `loadNewSSTables()` Scan through Keyspace/ColumnFamily's data directory determine which SSTables should be loaded and load them
`void` `setCompactionParameters(java.util.Map<java.lang.String,java.lang.String> options)` Sets the compaction parameters locally for this node Note that this will be set until an ALTER with compaction = {..} is executed or the node is restarted
`void` `setCompactionParametersJson(java.lang.String options)` Sets the compaction parameters locally for this node Note that this will be set until an ALTER with compaction = {..} is executed or the node is restarted
`void` `setCompactionStrategyClass(java.lang.String className)` Deprecated.
`void` `setCompactionThresholds(int minThreshold, int maxThreshold)` Sets the maximum and maximum number of SSTables in queue before compaction kicks off
`void` `setCompressionParameters(java.util.Map<java.lang.String,java.lang.String> opts)` Set the compression parameters
`void` `setCrcCheckChance(double crcCheckChance)` Set new crc check chance
`void` `setMaximumCompactionThreshold(int threshold)` Sets the maximum number of sstables in queue before compaction kicks off
`void` `setMinimumCompactionThreshold(int threshold)` Sets the minimum number of sstables in queue before compaction kicks off
`long` `trueSnapshotsSize()`

### Method Detail

#### getColumnFamilyName

    java.lang.String getColumnFamilyName()

Returns:
  the name of the column family

#### forceMajorCompaction

    void forceMajorCompaction(boolean splitOutput)
                       throws java.util.concurrent.ExecutionException,
                              java.lang.InterruptedException

force a major compaction of this column family

Parameters:
  `splitOutput` - true if the output of the major compaction should be split in several sstables
Throws:
  `java.util.concurrent.ExecutionException`
  `java.lang.InterruptedException`

#### getMinimumCompactionThreshold

    int getMinimumCompactionThreshold()

Gets the minimum number of sstables in queue before compaction kicks off

#### setMinimumCompactionThreshold

    void setMinimumCompactionThreshold(int threshold)

Sets the minimum number of sstables in queue before compaction kicks off

#### getMaximumCompactionThreshold

    int getMaximumCompactionThreshold()

Gets the maximum number of sstables in queue before compaction kicks off

#### setCompactionThresholds

    void setCompactionThresholds(int minThreshold,
                                 int maxThreshold)

Sets the maximum and maximum number of SSTables in queue before compaction kicks off

#### setMaximumCompactionThreshold

    void setMaximumCompactionThreshold(int threshold)

Sets the maximum number of sstables in queue before compaction kicks off

#### setCompactionParametersJson

    void setCompactionParametersJson(java.lang.String options)

Sets the compaction parameters locally for this node Note that this will be set until an ALTER with compaction = {..} is executed or the node is restarted

Parameters:
  `options` - compaction options with the same syntax as when doing ALTER ... WITH compaction = {..}

#### getCompactionParametersJson

    java.lang.String getCompactionParametersJson()

#### setCompactionParameters

    void setCompactionParameters(java.util.Map<java.lang.String,java.lang.String> options)

Sets the compaction parameters locally for this node Note that this will be set until an ALTER with compaction = {..} is executed or the node is restarted

Parameters:
  `options` - compaction options map

#### getCompactionParameters

    java.util.Map<java.lang.String,java.lang.String> getCompactionParameters()

#### setCompactionStrategyClass

    @Deprecated
    void setCompactionStrategyClass(java.lang.String className)

Deprecated.
Sets the compaction strategy by class name

Parameters:
  `className` - the name of the compaction strategy class

#### getCompactionStrategyClass

    @Deprecated
    java.lang.String getCompactionStrategyClass()

Deprecated.
Gets the compaction strategy class name

#### getCompressionParameters

    java.util.Map<java.lang.String,java.lang.String> getCompressionParameters()

Get the compression parameters

#### setCompressionParameters

    void setCompressionParameters(java.util.Map<java.lang.String,java.lang.String> opts)

Set the compression parameters

Parameters:
  `opts` - map of string names to values

#### setCrcCheckChance

    void setCrcCheckChance(double crcCheckChance)

Set new crc check chance

#### isAutoCompactionDisabled

    boolean isAutoCompactionDisabled()

#### estimateKeys

    long estimateKeys()

#### getBuiltIndexes

    java.util.List<java.lang.String> getBuiltIndexes()

Returns a list of the names of the built column indexes for current store

Returns:
  list of the index names

#### getSSTablesForKey

    java.util.List<java.lang.String> getSSTablesForKey(java.lang.String key)

Returns a list of filenames that contain the given key on this node

Parameters:
  `key` -
Returns:
  list of filenames containing the key

#### loadNewSSTables

    void loadNewSSTables()

Scan through Keyspace/ColumnFamily's data directory determine which SSTables should be loaded and load them

#### getUnleveledSSTables

    int getUnleveledSSTables()

Returns:
  the number of SSTables in L0. Always return 0 if Leveled compaction is not enabled.

#### getSSTableCountPerLevel

    int[] getSSTableCountPerLevel()

Returns:
  sstable count for each level. null unless leveled compaction is used. array index corresponds to level(int[0] is for level 0, ...).

#### getDroppableTombstoneRatio

    double getDroppableTombstoneRatio()

Get the ratio of droppable tombstones to real columns (and non-droppable tombstones)

Returns:
  ratio

#### trueSnapshotsSize

    long trueSnapshotsSize()

Returns:
  the size of SSTables in "snapshots" subdirectory which aren't live anymore

#### beginLocalSampling

    void beginLocalSampling(java.lang.String sampler,
                            int capacity)

begin sampling for a specific sampler with a given capacity. The cardinality may be larger than the capacity, but depending on the use case it may affect its accuracy

#### finishLocalSampling

    javax.management.openmbean.CompositeData finishLocalSampling(java.lang.String sampler,
                                                                 int count)
                                                          throws javax.management.openmbean.OpenDataException

Returns:
  top count items for the sampler since beginLocalSampling was called
Throws:
  `javax.management.openmbean.OpenDataException`